#include <stdlib.h>
#include <vstypes.h>
#include <lcd.h>
#include "graphics.h"

auto void DrawLine(register u_int16 x0, register u_int16 y0,
                   register u_int16 x1, register u_int16 y1,
                   u_int16 color) {
  int steep;
  int deltax;
  int deltay;
  int error;
  int ystep;
  int x, y;

  if (y0 == y1 || x0 == x1) {
    LcdFilledRectangle(x0, y0, x1, y1, NULL, color);
    return;
  }

  steep = abs(y1 - y0) > abs(x1 - x0);
  if (steep) {
    u_int16 t;
    t = x0; x0 = y0; y0 = t;
    t = x1; x1 = y1; y1 = t;
  }
  if (x0 > x1) {
    u_int16 t;
    t = x0; x0 = x1; x1 = t;
    t = y0; y0 = y1; y1 = t;
  }
  deltax = x1 - x0;
  deltay = abs(y1 - y0);
  error = deltax / 2;
  y = y0;
  if (y0 < y1) {
    ystep = 1;
  } else {
    ystep = -1;
  }
  for (x = x0; x <= x1; x++) {
    if (steep) {
      LcdFilledRectangle(y, x, y, x, NULL, color);
    } else {
      LcdFilledRectangle(x, y, x, y, NULL, color);
    }
    error -= deltay;
    if (error < 0) {
      y += ystep;
      error += deltax;
    }
  } /* for (x...) */
}
